--- linux-2.6.18.2/arch/alpha/kernel/semaphore.c	2004-08-14 12:55:32 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/alpha/kernel/semaphore.c	2006-10-28 19:27:34 +0200
@@ -68,8 +68,8 @@ __down_failed(struct semaphore *sem)
 	DECLARE_WAITQUEUE(wait, tsk);
 
 #ifdef CONFIG_DEBUG_SEMAPHORE
-	printk("%s(%d): down failed(%p)\n",
-	       tsk->comm, tsk->pid, sem);
+	printk("%s(%d:#%u): down failed(%p)\n",
+	       tsk->comm, tsk->pid, tsk->xid, sem);
 #endif
 
 	tsk->state = TASK_UNINTERRUPTIBLE;
--- linux-2.6.18.2/arch/alpha/kernel/semaphore.c	2004-08-14 12:55:32 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/alpha/kernel/semaphore.c	2006-10-28 19:27:34 +0200
@@ -97,8 +97,8 @@ __down_failed(struct semaphore *sem)
 	wake_up(&sem->wait);
 
 #ifdef CONFIG_DEBUG_SEMAPHORE
-	printk("%s(%d): down acquired(%p)\n",
-	       tsk->comm, tsk->pid, sem);
+	printk("%s(%d:#%u): down acquired(%p)\n",
+	       tsk->comm, tsk->pid, tsk->xid, sem);
 #endif
 }
 
--- linux-2.6.18.2/arch/alpha/kernel/semaphore.c	2004-08-14 12:55:32 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/alpha/kernel/semaphore.c	2006-10-28 19:27:34 +0200
@@ -110,8 +110,8 @@ __down_failed_interruptible(struct semap
 	long ret = 0;
 
 #ifdef CONFIG_DEBUG_SEMAPHORE
-	printk("%s(%d): down failed(%p)\n",
-	       tsk->comm, tsk->pid, sem);
+	printk("%s(%d:#%u): down failed(%p)\n",
+	       tsk->comm, tsk->pid, tsk->xid, sem);
 #endif
 
 	tsk->state = TASK_INTERRUPTIBLE;
--- linux-2.6.18.2/arch/alpha/kernel/traps.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/alpha/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -182,7 +182,8 @@ die_if_kernel(char * str, struct pt_regs
 #ifdef CONFIG_SMP
 	printk("CPU %d ", hard_smp_processor_id());
 #endif
-	printk("%s(%d): %s %ld\n", current->comm, current->pid, str, err);
+	printk("%s(%d[#%u]): %s %ld\n", current->comm,
+		current->pid, current->xid, str, err);
 	dik_show_regs(regs, r9_15);
 	dik_show_trace((unsigned long *)(regs+1));
 	dik_show_code((unsigned int *)regs->pc);
--- linux-2.6.18.2/arch/arm/kernel/process.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/arm/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -236,7 +236,8 @@ void __show_regs(struct pt_regs *regs)
 void show_regs(struct pt_regs * regs)
 {
 	printk("\n");
-	printk("Pid: %d, comm: %20s\n", current->pid, current->comm);
+	printk("Pid: %d[#%u], comm: %20s\n",
+		current->pid, current->xid, current->comm);
 	__show_regs(regs);
 	__backtrace();
 }
--- linux-2.6.18.2/arch/arm/kernel/traps.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/arm/kernel/traps.c	2006-10-28 19:27:58 +0200
@@ -205,8 +205,8 @@ static void __die(const char *str, int e
 	printk("Internal error: %s: %x [#%d]\n", str, err, ++die_counter);
 	print_modules();
 	__show_regs(regs);
-	printk("Process %s (pid: %d, stack limit = 0x%p)\n",
-		tsk->comm, tsk->pid, thread + 1);
+	printk("Process %s (pid: %d:#%u, stack limit = 0x%p)\n",
+		tsk->comm, tsk->pid, tsk->xid, thread + 1);
 
 	if (!user_mode(regs) || in_interrupt()) {
 		dump_mem("Stack: ", regs->ARM_sp,
--- linux-2.6.18.2/arch/arm26/kernel/traps.c	2006-09-20 16:57:57 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/arm26/kernel/traps.c	2006-09-20 17:01:44 +0200
@@ -185,8 +185,9 @@ NORET_TYPE void die(const char *str, str
 	printk("Internal error: %s: %x\n", str, err);
 	printk("CPU: %d\n", smp_processor_id());
 	show_regs(regs);
-	printk("Process %s (pid: %d, stack limit = 0x%p)\n",
-		current->comm, current->pid, end_of_stack(tsk));
+	printk("Process %s (pid: %d[#%u], stack limit = 0x%p)\n",
+		current->comm, current->pid,
+		current->xid, end_of_stack(tsk));
 
 	if (!user_mode(regs) || in_interrupt()) {
 		__dump_stack(tsk, (unsigned long)(regs + 1));
--- linux-2.6.18.2/arch/i386/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/i386/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -289,8 +289,10 @@ void show_regs(struct pt_regs * regs)
 	unsigned long cr0 = 0L, cr2 = 0L, cr3 = 0L, cr4 = 0L;
 
 	printk("\n");
-	printk("Pid: %d, comm: %20s\n", current->pid, current->comm);
-	printk("EIP: %04x:[<%08lx>] CPU: %d\n",0xffff & regs->xcs,regs->eip, smp_processor_id());
+	printk("Pid: %d[#%u], comm: %20s\n",
+		current->pid, current->xid, current->comm);
+	printk("EIP: %04x:[<%08lx>] CPU: %d\n",
+		0xffff & regs->xcs,regs->eip, smp_processor_id());
 	print_symbol("EIP is at %s\n", regs->eip);
 
 	if (user_mode_vm(regs))
--- linux-2.6.18.2/arch/i386/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/i386/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -304,8 +306,8 @@ void show_registers(struct pt_regs *regs
 		regs->esi, regs->edi, regs->ebp, esp);
 	printk(KERN_EMERG "ds: %04x   es: %04x   ss: %04x\n",
 		regs->xds & 0xffff, regs->xes & 0xffff, ss);
-	printk(KERN_EMERG "Process %.*s (pid: %d, ti=%p task=%p task.ti=%p)",
-		TASK_COMM_LEN, current->comm, current->pid,
+	printk(KERN_EMERG "Process %.*s (pid: %d[#%u], ti=%p task=%p task.ti=%p)",
+		TASK_COMM_LEN, current->comm, current->pid, current->xid,
 		current_thread_info(), current, current->thread_info);
 	/*
 	 * When in-kernel, we also print out the stack and code at the
--- linux-2.6.18.2/arch/ia64/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/ia64/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -107,7 +107,8 @@ show_regs (struct pt_regs *regs)
 	unsigned long ip = regs->cr_iip + ia64_psr(regs)->ri;
 
 	print_modules();
-	printk("\nPid: %d, CPU %d, comm: %20s\n", current->pid, smp_processor_id(), current->comm);
+	printk("\nPid: %d[#%u], CPU %d, comm: %20s\n",
+		current->pid, current->xid, smp_processor_id(), current->comm);
 	printk("psr : %016lx ifs : %016lx ip  : [<%016lx>]    %s\n",
 	       regs->cr_ipsr, regs->cr_ifs, ip, print_tainted());
 	print_symbol("ip is at %s\n", ip);
--- linux-2.6.18.2/arch/ia64/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/ia64/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -106,8 +106,9 @@ die (const char *str, struct pt_regs *re
 	put_cpu();
 
 	if (++die.lock_owner_depth < 3) {
-		printk("%s[%d]: %s %ld [%d]\n",
-			current->comm, current->pid, str, err, ++die_counter);
+		printk("%s[%d[#%u]]: %s %ld [%d]\n",
+			current->comm, current->pid, current->xid,
+			str, err, ++die_counter);
 		(void) notify_die(DIE_OOPS, (char *)str, regs, err, 255, SIGSEGV);
 		show_regs(regs);
   	} else
--- linux-2.6.18.2/arch/ia64/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/ia64/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -331,8 +332,9 @@ handle_fpu_swa (int fp_fault, struct pt_
 		last_time = jiffies;
 		++fpu_swa_count;
 		printk(KERN_WARNING
-		       "%s(%d): floating-point assist fault at ip %016lx, isr %016lx\n",
-		       current->comm, current->pid, regs->cr_iip + ia64_psr(regs)->ri, isr);
+		       "%s(%d[#%u]): floating-point assist fault at ip %016lx, isr %016lx\n",
+		       current->comm, current->pid, current->xid,
+		       regs->cr_iip + ia64_psr(regs)->ri, isr);
 	}
 
 	exception = fp_emulate(fp_fault, bundle, &regs->cr_ipsr, &regs->ar_fpsr, &isr, &regs->pr,
--- linux-2.6.18.2/arch/m32r/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/m32r/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -195,8 +195,9 @@ static void show_registers(struct pt_reg
 	} else {
 		printk("SPI: %08lx\n", sp);
 	}
-	printk("Process %s (pid: %d, process nr: %d, stackpage=%08lx)",
-		current->comm, current->pid, 0xffff & i, 4096+(unsigned long)current);
+	printk("Process %s (pid: %d[#%u], process nr: %d, stackpage=%08lx)",
+		current->comm, current->pid, current->xid,
+		0xffff & i, 4096+(unsigned long)current);
 
 	/*
 	 * When in-kernel, we also print out the stack and code at the
--- linux-2.6.18.2/arch/m68k/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/m68k/kernel/traps.c	2006-09-25 17:16:58 +0200
@@ -899,8 +899,8 @@ void show_registers(struct pt_regs *regs
 	printk("d4: %08lx    d5: %08lx    a0: %08lx    a1: %08lx\n",
 	       regs->d4, regs->d5, regs->a0, regs->a1);
 
-	printk("Process %s (pid: %d, task=%p)\n",
-		current->comm, current->pid, current);
+	printk("Process %s (pid: %d[#%u], task=%p)\n",
+		current->comm, current->pid, current->xid, current);
 	addr = (unsigned long)&fp->un;
 	printk("Frame format=%X ", regs->format);
 	switch (regs->format) {
--- linux-2.6.18.2/arch/m68knommu/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/m68knommu/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -80,8 +80,9 @@ void die_if_kernel(char *str, struct pt_
 	printk(KERN_EMERG "d4: %08lx    d5: %08lx    a0: %08lx    a1: %08lx\n",
 	       fp->d4, fp->d5, fp->a0, fp->a1);
 
-	printk(KERN_EMERG "Process %s (pid: %d, stackpage=%08lx)\n",
-		current->comm, current->pid, PAGE_SIZE+(unsigned long)current);
+	printk(KERN_EMERG "Process %s (pid: %d[#%u], stackpage=%08lx)\n",
+		current->comm, current->pid, current->xid,
+		PAGE_SIZE+(unsigned long)current);
 	show_stack(NULL, (unsigned long *)fp);
 	do_exit(SIGSEGV);
 }
--- linux-2.6.18.2/arch/mips/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/mips/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -266,8 +266,9 @@ void show_registers(struct pt_regs *regs
 {
 	show_regs(regs);
 	print_modules();
-	printk("Process %s (pid: %d, threadinfo=%p, task=%p)\n",
-	        current->comm, current->pid, current_thread_info(), current);
+	printk("Process %s (pid: %d[#%u], threadinfo=%p, task=%p)\n",
+		current->comm, current->pid, current->xid,
+		current_thread_info(), current);
 	show_stack(current, (long *) regs->regs[29]);
 	show_trace(current, (long *) regs->regs[29]);
 	show_code((unsigned int *) regs->cp0_epc);
--- linux-2.6.18.2/arch/parisc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/parisc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -209,8 +209,9 @@ void die_if_kernel(char *str, struct pt_
 		if (err == 0)
 			return; /* STFU */
 
-		printk(KERN_CRIT "%s (pid %d): %s (code %ld) at " RFMT "\n",
-			current->comm, current->pid, str, err, regs->iaoq[0]);
+		printk(KERN_CRIT "%s (pid %d[#%u]): %s (code %ld) at " RFMT "\n",
+			current->comm, current->pid, current->xid,
+			str, err, regs->iaoq[0]);
 #ifdef PRINT_USER_FAULTS
 		/* XXX for debugging only */
 		show_regs(regs);
--- linux-2.6.18.2/arch/parisc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/parisc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -241,8 +242,8 @@ void die_if_kernel(char *str, struct pt_
 	if (!console_drivers)
 		pdc_console_restart();
 	
-	printk(KERN_CRIT "%s (pid %d): %s (code %ld)\n",
-		current->comm, current->pid, str, err);
+	printk(KERN_CRIT "%s (pid %d[#%u]): %s (code %ld)\n",
+		current->comm, current->pid, current->xid, str, err);
 	show_regs(regs);
 
 	/* Wot's wrong wif bein' racy? */
--- linux-2.6.18.2/arch/parisc/mm/fault.c	2006-06-18 04:52:15 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/parisc/mm/fault.c	2006-10-28 19:28:40 +0200
@@ -213,8 +213,9 @@ bad_area:
 
 #ifdef PRINT_USER_FAULTS
 		printk(KERN_DEBUG "\n");
-		printk(KERN_DEBUG "do_page_fault() pid=%d command='%s' type=%lu address=0x%08lx\n",
-		    tsk->pid, tsk->comm, code, address);
+		printk(KERN_DEBUG "do_page_fault() pid=%d:#%u "
+		    "command='%s' type=%lu address=0x%08lx\n",
+		    tsk->pid, tsk->xid, tsk->comm, code, address);
 		if (vma) {
 			printk(KERN_DEBUG "vm_start = 0x%08lx, vm_end = 0x%08lx\n",
 					vma->vm_start, vma->vm_end);
--- linux-2.6.18.2/arch/powerpc/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/powerpc/kernel/process.c	2006-09-20 17:01:44 +0200
@@ -431,8 +431,9 @@ void show_regs(struct pt_regs * regs)
 	trap = TRAP(regs);
 	if (trap == 0x300 || trap == 0x600)
 		printk("DAR: "REG", DSISR: "REG"\n", regs->dar, regs->dsisr);
-	printk("TASK = %p[%d] '%s' THREAD: %p",
-	       current, current->pid, current->comm, task_thread_info(current));
+	printk("TASK = %p[%d,#%u] '%s' THREAD: %p",
+	       current, current->pid, current->xid,
+	       current->comm, task_thread_info(current));
 
 #ifdef CONFIG_SMP
 	printk(" CPU: %d", smp_processor_id());
--- linux-2.6.18.2/arch/powerpc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/powerpc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -861,8 +861,9 @@ void nonrecoverable_exception(struct pt_
 
 void trace_syscall(struct pt_regs *regs)
 {
-	printk("Task: %p(%d), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
-	       current, current->pid, regs->nip, regs->link, regs->gpr[0],
+	printk("Task: %p(%d[#%u]), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
+	       current, current->pid, current->xid,
+	       regs->nip, regs->link, regs->gpr[0],
 	       regs->ccr&0x10000000?"Error=":"", regs->gpr[3], print_tainted());
 }
 
--- linux-2.6.18.2/arch/ppc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/ppc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -746,8 +746,9 @@ void nonrecoverable_exception(struct pt_
 
 void trace_syscall(struct pt_regs *regs)
 {
-	printk("Task: %p(%d), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
-	       current, current->pid, regs->nip, regs->link, regs->gpr[0],
+	printk("Task: %p(%d[#%u]), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
+	       current, current->pid, current->xid,
+	       regs->nip, regs->link, regs->gpr[0],
 	       regs->ccr&0x10000000?"Error=":"", regs->gpr[3], print_tainted());
 }
 
--- linux-2.6.18.2/arch/s390/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/s390/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -165,9 +165,9 @@ void show_regs(struct pt_regs *regs)
 	struct task_struct *tsk = current;
 
         printk("CPU:    %d    %s\n", task_thread_info(tsk)->cpu, print_tainted());
-        printk("Process %s (pid: %d, task: %p, ksp: %p)\n",
-	       current->comm, current->pid, (void *) tsk,
-	       (void *) tsk->thread.ksp);
+	printk("Process %s (pid: %d[#%u], task: %p, ksp: %p)\n",
+	       current->comm, current->pid, current->xid,
+	       (void *) tsk, (void *) tsk->thread.ksp);
 
 	show_registers(regs);
 	/* Show stack backtrace if pt_regs is from kernel mode */
--- linux-2.6.18.2/arch/sh/kernel/process.c	2006-11-04 19:43:22 +0100
+++ linux-2.6.18.2-vs2.1.1/arch/sh/kernel/process.c	2006-10-18 01:14:30 +0200
@@ -113,7 +113,8 @@ void machine_power_off(void)
 void show_regs(struct pt_regs * regs)
 {
 	printk("\n");
-	printk("Pid : %d, Comm: %20s\n", current->pid, current->comm);
+	printk("Pid : %d[#%u], Comm: %20s\n",
+		current->pid, current->xid, current->comm);
 	print_symbol("PC is at %s\n", regs->pc);
 	printk("PC  : %08lx SP  : %08lx SR  : %08lx ",
 	       regs->pc, regs->regs[15], regs->sr);
--- linux-2.6.18.2/arch/sh/kernel/setup.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/sh/kernel/setup.c	2006-09-20 17:01:44 +0200
@@ -481,7 +482,7 @@ static int show_cpuinfo(struct seq_file 
 		seq_printf(m, "machine\t\t: %s\n", get_system_type());
 
 	seq_printf(m, "processor\t: %d\n", cpu);
-	seq_printf(m, "cpu family\t: %s\n", system_utsname.machine);
+	seq_printf(m, "cpu family\t: %s\n", vx_new_uts(machine));
 	seq_printf(m, "cpu type\t: %s\n", get_cpu_subtype());
 
 	show_cpuflags(m);
--- linux-2.6.18.2/arch/sh64/mm/fault.c	2005-08-29 22:24:56 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/sh64/mm/fault.c	2006-10-28 19:29:06 +0200
@@ -82,7 +82,7 @@ static inline void print_vma(struct vm_a
 
 static inline void print_task(struct task_struct *tsk)
 {
-	printk("Task pid %d\n", tsk->pid);
+	printk("Task pid %d:#%u\n", tsk->pid, tsk->xid);
 }
 
 static pte_t *lookup_pte(struct mm_struct *mm, unsigned long address)
--- linux-2.6.18.2/arch/sparc/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/sparc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -99,7 +99,8 @@ void die_if_kernel(char *str, struct pt_
 "              /_| \\__/ |_\\\n"
 "                 \\__U_/\n");
 
-	printk("%s(%d): %s [#%d]\n", current->comm, current->pid, str, ++die_counter);
+	printk("%s(%d[#%u]): %s [#%d]\n", current->comm,
+		current->pid, current->xid, str, ++die_counter);
 	show_regs(regs);
 
 	__SAVE; __SAVE; __SAVE; __SAVE;
--- linux-2.6.18.2/arch/sparc64/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/sparc64/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -2215,7 +2215,8 @@ void die_if_kernel(char *str, struct pt_
 "              /_| \\__/ |_\\\n"
 "                 \\__U_/\n");
 
-	printk("%s(%d): %s [#%d]\n", current->comm, current->pid, str, ++die_counter);
+	printk("%s(%d[#%u]): %s [#%d]\n", current->comm,
+		current->pid, current->xid, str, ++die_counter);
 	notify_die(DIE_OOPS, str, regs, 0, 255, SIGSEGV);
 	__asm__ __volatile__("flushw");
 	__show_regs(regs);
--- linux-2.6.18.2/arch/x86_64/kernel/process.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/x86_64/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -289,8 +290,8 @@ void __show_regs(struct pt_regs * regs)
 
 	printk("\n");
 	print_modules();
-	printk("Pid: %d, comm: %.20s %s %s %.*s\n",
-		current->pid, current->comm, print_tainted(),
+	printk("Pid: %d[#%u], comm: %.20s %s %s %.*s\n",
+		current->pid, current->xid, current->comm, print_tainted(),
 		system_utsname.release,
 		(int)strcspn(system_utsname.version, " "),
 		system_utsname.version);
--- linux-2.6.18.2/arch/x86_64/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/x86_64/kernel/traps.c	2006-10-28 19:26:17 +0200
@@ -435,8 +435,9 @@ void show_registers(struct pt_regs *regs
 
 	printk("CPU %d ", cpu);
 	__show_regs(regs);
-	printk("Process %s (pid: %d, threadinfo %p, task %p)\n",
-		cur->comm, cur->pid, task_thread_info(cur), cur);
+	printk("Process %s (pid: %d[#%u], threadinfo %p, task %p)\n",
+		cur->comm, cur->pid, cur->xid,
+		task_thread_info(cur), cur);
 
 	/*
 	 * When in-kernel, we also print out the stack and code at the
--- linux-2.6.18.2/arch/x86_64/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/x86_64/kernel/traps.c	2006-10-28 19:26:17 +0200
@@ -603,8 +604,8 @@ static void __kprobes do_trap(int trapnr
 	if (user_mode(regs)) {
 		if (exception_trace && unhandled_signal(tsk, signr))
 			printk(KERN_INFO
-			       "%s[%d] trap %s rip:%lx rsp:%lx error:%lx\n",
-			       tsk->comm, tsk->pid, str,
+			       "%s[%d:#%u] trap %s rip:%lx rsp:%lx error:%lx\n",
+			       tsk->comm, tsk->pid, tsk->xid, str,
 			       regs->rip, regs->rsp, error_code); 
 
 		if (info)
--- linux-2.6.18.2/arch/x86_64/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/x86_64/kernel/traps.c	2006-10-28 19:26:17 +0200
@@ -704,8 +705,8 @@ asmlinkage void __kprobes do_general_pro
 	if (user_mode(regs)) {
 		if (exception_trace && unhandled_signal(tsk, SIGSEGV))
 			printk(KERN_INFO
-		       "%s[%d] general protection rip:%lx rsp:%lx error:%lx\n",
-			       tsk->comm, tsk->pid,
+		       "%s[%d:#%u] general protection rip:%lx rsp:%lx error:%lx\n",
+			       tsk->comm, tsk->pid, tsk->xid,
 			       regs->rip, regs->rsp, error_code); 
 
 		force_sig(SIGSEGV, tsk);
--- linux-2.6.18.2/arch/x86_64/mm/fault.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18.2-vs2.1.1/arch/x86_64/mm/fault.c	2006-10-28 19:30:33 +0200
@@ -520,10 +520,10 @@ bad_area_nosemaphore:
 
 		if (exception_trace && unhandled_signal(tsk, SIGSEGV)) {
 			printk(
-		       "%s%s[%d]: segfault at %016lx rip %016lx rsp %016lx error %lx\n",
+		       "%s%s[%d:#%u]: segfault at %016lx rip %016lx rsp %016lx error %lx\n",
 					tsk->pid > 1 ? KERN_INFO : KERN_EMERG,
-					tsk->comm, tsk->pid, address, regs->rip,
-					regs->rsp, error_code);
+					tsk->comm, tsk->pid, tsk->xid, address,
+					regs->rip, regs->rsp, error_code);
 		}
        
 		tsk->thread.cr2 = address;
--- linux-2.6.18.2/mm/oom_kill.c	2006-09-20 16:58:45 +0200
+++ linux-2.6.18.2-vs2.1.1/mm/oom_kill.c	2006-09-25 15:40:02 +0200
@@ -241,8 +243,8 @@ static void __oom_kill_task(struct task_
 		return;
 	}
 	task_unlock(p);
-	printk(KERN_ERR "%s: Killed process %d (%s).\n",
-				message, p->pid, p->comm);
+	printk(KERN_ERR "%s: Killed process %d[#%u] (%s).\n",
+		message, p->pid, p->xid, p->comm);
 
 	/*
 	 * We give our sacrificial lamb high priority and access to